#!/usr/bin/env python

import sys
import dbus

def fso_auth(pin):
    bus = dbus.SystemBus()

    usage_obj = bus.get_object("org.freesmartphone.ousaged", "/org/freesmartphone/Usage")
    usage_iface = dbus.Interface(usage_obj, "org.freesmartphone.Usage")
    usage_iface.RequestResource("GSM")

    gsm_device_obj = bus.get_object("org.freesmartphone.ogsmd", "/org/freesmartphone/GSM/Device")
    gsm_sim_iface = dbus.Interface(gsm_device_obj, "org.freesmartphone.GSM.SIM")

    if gsm_sim_iface.GetAuthStatus()  == 'SIM PIN':
        gsm_sim_iface.SendAuthCode(pin)
        if gsm_sim_iface.GetAuthStatus() == 'READY':
            print "OK"

    usage_iface.ReleaseResource("GSM")

if __name__ == "__main__":

    if len(sys.argv) != 2:
        sys.stderr.write("usage: %s <pin>\n")
        sys.exit(1)

    pin = sys.argv[1]
    fso_auth(pin)
